package com.oracle.truffle.r.engine;

import java.io.Serializable;

import org.apache.hadoop.hive.ql.exec.UDF;

import com.oracle.truffle.api.source.Source;
import com.oracle.truffle.api.vm.PolyglotEngine;
import com.oracle.truffle.api.vm.PolyglotEngine.Value;
import com.oracle.truffle.r.runtime.RRuntime;

public class RExecute extends UDF {
    public static String evaluate(final String program) {
        final Value v = PolyglotEngine.newBuilder().config("application/x-r", "REngine", null).build().eval(Source.newBuilder(program).name("RBuilder").mimeType(RRuntime.R_APP_MIME).build());
        final Object res = v.get();
        if (res instanceof Serializable)
            return res.toString();
        return v.getSourceLocation().getCode();
    }
}
